//====================================================================================//
//                                                                                    //
//                              PEPS Solution Methods                                 //
//                                                                                    //
//====================================================================================//
//  This File:   solve.C                    Language: C++  (xlC and CC)               //
//  Software:    PEPS 2002                   Advisor: Brigitte.Plateau@imag.fr        //
//  Doc:         solve.tex                                                            //
//====================================================================================//
//  Creation:    19/dec/95                        by: Paulo.Fernandes@imag.fr         //
//  Last Change: 06/nov/02                        by: paulof@inf.pucrs.br             //
//====================================================================================//
#include "peps.h"

//====================================================================================//
//  Power HBF                                                                         //
//====================================================================================//

bool Power_HBF(VCT & buf)
{
 int       i;
 int       half, rest;
 rp        error;
 rp        resid;
 i_typ     iteration_type;
 e_typ     error_test_type;
 Timer     T;

 HBF::hbf.scale();
 iteration_type  = PRF::prf.it_type();
 error_test_type = PRF::prf.err_type();
 half            = PRF::prf.max_it() / 2;
 rest            = PRF::prf.max_it() % 2;
 error           = PRF::prf.min_err();

 T.clear(); T.start();
 switch (iteration_type) {
   case fix_it : for (i=0; i<half; i++) {
                   VCT::vct.mult_HBF(buf);
                   buf.mult_HBF(VCT::vct);
                 }
                 if (rest == 0)
                   VCT::vct.copy(buf);
                 else
                   VCT::vct.mult_HBF(buf);
                 break;
   default     : VCT::vct.mult_HBF(buf);
                 for (i=0; i<half; i++) {
                   if (VCT::vct.test(buf, error_test_type, error))
                     break;
                   buf.mult_HBF(VCT::vct);
                   VCT::vct.mult_HBF(buf);
                 }
 }
 T.stop();
   if (PRF::prf.it_type() == cnv_it) {        // Convergence verification
     buf.mult_HBF(VCT::vct);                  //   One extra multiplication is made
     resid = buf.test(VCT::vct, error_test_type, error); //     and the largest element is
   }                                                  //     considered as the residue
 Notify_Time_Spend(T, "HBF power solution", (i*2)+rest, resid);
 VCT::vct.write();
 return(resid < PRF::prf.min_err());
}
