//====================================================================================//
//                                                                                    //
//                                    PEPS Main                                       //
//                                                                                    //
//====================================================================================//
//  This File:   peps.C                     Language: C++  (xlC and CC)               //
//  Software:    PEPS 2003                   Advisor: Brigitte.Plateau@imag.fr        //
//====================================================================================//
//  Creation:    19/dec/95                        by: Paulo.Fernandes@imag.fr         //
//  Last Change: 13/feb/03                        by: Anne.Benoit@imag.fr         //
//====================================================================================//
#include "peps.h"

peps_name filename;

//====================================================================================//
void Power_hbf()
//====================================================================================//
{
 peps_name name;
 VCT       buf;

 if (Provide_HBF(filename)) {
   HBF::hbf.name(name);
   cout << "\nSolution of the model '" << name << ".hbf' ("
        << HBF::hbf.size() << " nonzeros - " << HBF::hbf.order() << " states)\n";
   Ask_a_File_Name(name, vct_file);
   if (Permission_to_Proceed(name, vct_file)) {
     VCT::vct.create(HBF::hbf.order());
     VCT::vct.baptise(name);
     if (PRF::prf.i_vec() != in_vec) {
       buf.create(HBF::hbf.order());
       buf.init_hbf(PRF::prf.i_vec());
     }
     else
       do {
         Ask_an_Existing_File_Name(name, vct_file);
         buf.read(name);
       } while (buf.size() != VCT::vct.size());
     if (Power_HBF(buf))
       cout << "Convergence!\n";
   }
 }
}


//====================================================================================//
//====================================================================================//

//====================================================================================//
//                                    PEPS Main                                       //
//====================================================================================//
int main(int argc, char *argv[])
{
 cout.setf(ios::scientific);
 cout.precision(16);
 set_new_handler(Communicate_Out_of_Memory);
 Create_Temporary_Directories();
 peps_name aux;

 strcpy(filename,""); 

 if (argc >= 2){
   for (int i=1; i<argc; i++){
     if (argv[i][0] == '-'){
       if (!(strcmp(argv[i], "-iter"))){
         PRF::prf.max_it(atol(argv[i+1]));   i++;
         cout << "Maximum number of iterations: " << atol(argv[i]) << endl;
       }// end iter 
       if (!(strcmp(argv[i], "-min_err"))){
         PRF::prf.min_err(atof(argv[i+1]));   i++;
         cout << "Tolerance accepted: " << atof(argv[i]) << endl;
       }
       if (!(strcmp(argv[i], "-iter_type"))){
         if (!(strcmp(argv[i+1], "fix"))) {
           PRF::prf.it_type(fix_it); i++;
         }
         else{
           if (!(strcmp(argv[i+1], "stb"))) {
             PRF::prf.it_type(stb_it);  i++;
           }
           else{
             if (!(strcmp(argv[i+1], "cnv"))) {
               PRF::prf.it_type(cnv_it);   i++;
             }
             else{
               cout << "error: " << argv[i+1] << " is a invalid option to " << argv[i] << endl;
               exit (0);
             }
           }
         } 
         PRF::prf.sit_type(aux);
         cout << "Stop iteration criterion: " << aux << endl; 
       }
       if (!(strcmp(argv[i], "-err_type"))){
         if (!(strcmp(argv[i+1], "abs_ind"))) {
           PRF::prf.err_type(abs_ind_err);  i++;
         }
         else{
           if (!(strcmp(argv[i+1], "abs_acc"))) {
             PRF::prf.err_type(abs_acc_err);  i++;
           }
           else{
             if (!(strcmp(argv[i+1], "abs_ind"))) {
               PRF::prf.err_type(rel_ind_err);  i++;
             }
             else{
               cout << "error: " << argv[i+1] << " is a invalid option to " << argv[i] <<  endl; 
               exit (0);
             }
           }
         } 
         PRF::prf.serr_type(aux);
         cout << "Error Test: " << aux << endl;
       }       
       if (!(strcmp(argv[i], "-vec_type"))){
         if (!(strcmp(argv[i+1], "eq"))) {
           PRF::prf.i_vec(eq_vec);  i++;
         }
         else{
           if (!(strcmp(argv[i+1], "in"))) {
             PRF::prf.i_vec(in_vec);  i++;
           }
           else{
             if (!(strcmp(argv[i+1], "ap"))) {
               PRF::prf.i_vec(ap_vec);  i++;
             }
             else{
               cout << "error: " << argv[i+1] << " is a invalid option to " << argv[i] <<  endl; 
               exit (0);
             }
           }
         } 
         PRF::prf.si_vec(aux);
         cout << "Initial vector: " << aux << endl;
       }
//       if ((strcmp(argv[i], "-iter")) && (strcmp(argv[i], "-min_err"))  && (strcmp(argv[i], "-iter_type")) && (strcmp(argv[i], "-err_type")) && 
//           (strcmp(argv[i], "-vec_type"))) {
//         cout << "error: " << argv[i] << " is a invalid option." << endl; 
//         exit (0);
//       }
     }
     else{ //filename
       if (!strcmp(filename, ""))
         strcpy(filename, argv[i]);
       else
        cout << "warning: model name is already set as " << filename << ". Ignoring " << argv[i] << endl; 
     }
   } 
 }
 
//====================================================================================//
//                                    HBF Operations                                  //
//====================================================================================//
 Power_hbf();                             

 Say_Goodbye();
 return(0);
}
