//====================================================================================//
//                                                                                    //
//                            Class Probability Vector                                //
//                                                                                    //
//====================================================================================//
//  This File:   vct2.C                     Language: C++  (xlC and CC)               //
//  Software:    PEPS 3.1                    Advisor: Brigitte.Plateau@imag.fr        //
//  Error Codes: 2400                                                                 //
//====================================================================================//
//  Creation:    19/dec/95                        by: Paulo.Fernandes@imag.fr         //
//  Last Change: 15/oct/98                        by: Paulo.Fernandes@imag.fr         //
//====================================================================================//
#include "peps.h"

     //--------------------------------------------------------------------------//
     //         Multiply by a HBF   -   'this' = 'v' + ('v' * 'HBF::hbf')        //
     //--------------------------------------------------------------------------//
     // Implementation:                                                          //
     //     - for all columns ('j');                                             //
     //       - it initializes the resulting element ('vec[j]') with the element //
     //       with the element of original vector ('v.vec[j]');                  //
     //       - it multiplies each nonzero element by the corresponding vector   //
     //       'v' element, adding to the resulting element of the vector 'this'; //
     //--------------------------------------------------------------------------//
void VCT::mult_HBF(const VCT & v)
{
#ifdef _PEPS_DEBUG_
  if (dimension != v.dimension)
    Programming_Error("different sized vectors", 2401)
  if (HBF::hbf.order() != dimension)
    Programming_Error("bad sized HBF", 2402)
#endif
 int k;                            // counter for the nonzero elements of the HBF matrix

 for (int j=0; j<HBF::hbf.dimension; j++) {                    // for all columns
   vec[j] = v.vec[j];                                             // initializes
   for (k=HBF::hbf.columns[j]; k<HBF::hbf.columns[j+1]; k++)      // multiplies nonzeros
     vec[j] += v.vec[HBF::hbf.rows[k]] * HBF::hbf.elements[k];    // adding to elements
 }
}

